# Blueprints

![Banner Image](https://i.imgur.com/fV8R9eg.png)

## Description

Looking for a content creator to create a tutorial video for this mod. Contact me on the Techtonica Discord server if you're interested, my display name is Equinox and you can find me in the modding channels.

## Important Note
I know this description is a huge wall of text, so I'm not expecting you to read it all at once. Just please read each section as you are about to perform that task. For example, when copying your first region, read the 'Copying A Region' section first. Make sure you've read the relevant section before reporting a bug.

Please contact 'Equinox' @cube_suite_dev on the Techtonica Discord in the modding-discusion channel for support if needed.

Don't forget to share your blueprints on the Techtonica Discord in the blueprint-sharing channel!

## Description
This mod adds the ability to copy and paste sections of your factory and save regions as blueprints, to be reused or shared. If you change the keybinds for this mod, please test them in game first. For example, if you change the keybind for rotating blueprints to 'R' and 'Shift + R', you will end up rotating buildables in your world, as I cannot block this input from the game yet. 

**Note:** As of V2.1.1 manual building and deconstructing is now blocked while copying, placing a blueprint or when the Build Queue has machines to build.

### Instructions

#### Copying A Region

1. Aim at a buildable (machine, powerfloor etc.). Make sure you can see the information panel in the bottom left for that machine.
1. Press Left Control + C (configurable) to begin copying.
1. Move to the opposite corner of the region you would like to copy.
1. Check that the blue box covers only what you want to copy. 
  1. Sometimes, a bug can cause the copy region to be very large. If this happens, try looking away from the end buildable and back to it again.
  1. You can press the arrow keys to grow the box in any direction. Press Left Shift + Up / Down to expand vertically.
  1. Hold Left Control while pressing the arrow keys to shrink the box.
  1. You cannot shrink the box to be smaller than the region you drew with the mouse.
1. Press Left Control + C (configurable) to end copying.
  1. Wait for the 'Finished Copying Region' notification to appear.
  1. This can take a few seconds for larger regions.
1. Press backspace (configurable) to cancel copying if you change your mind during this process.

#### Pasting A Region

1. Press Left Control + V to enter pasting mode.
1. The 'Build Error' sound will play if you cannot afford the blueprint and nothing will happen.
  1. You will see a notification showing what you are missing.
1. Holograms will appear to show where the blueprint will be pasted.
1. Press Z (configurabe) to rotate the blueprint clockwise.
1. Press Left Control + Z (configurable) to rotate the blueprint anti-clockwise.
1. Press the arrow keys to manually nudge the blueprint in that direction. Left Shift + Up / Down moves the blueprint vertically.
  1. You can press 'N' (configurable) to prevent the mouse moving the blueprint. 
1. Once you are happy with the blueprints placement, press Left Control + V (configurable) to paste the blueprint.
1. The holograms will stay in place and the buildings will be added to the build queue.
1. Buildings will be taken from your inventory as they are built.
1. **Important**: The build queue does not save. Do not quit the game while there are items in the queue, it will be very hard to manually finish the blueprint.
1. You cannot deconstruct holograms that are in the build queue, you must wait for them to build and then deconstruct them.
1. You can continue to paste blueprints while waiting for the build queue to process.

#### Opening The Blueprints Library

1. Press Left Control + X (configurable) to open the blueprints library.
1. You can press any of these keys to close the blueprints library:
  1. Esc (Will also pause the game)
  1. Tab (Will also open inventory)
  1. Q
  1. E

#### Navigating The Blueprints Library

**Note:** A 'Blueprint Book' is a named collection of blueprints or other Blueprint Books, think of them like a folder on your computer. 

The first time that you open the Blueprint Library each game, you will see the top level Blueprint Book called 'All Blueprints'. This one cannot be deleted. In the top right of this window, there are five buttons:

1. New Blueprint - This button creates a new blueprint from the latest copied region. See the next section for more details.
1. New Blueprint Book - This button creates a new Blueprint Book inside the Blueprint Book that you currently have open.
  1. Think of it as the 'New Folder' button in Windows Explorer.
  1. A panel called 'New Book' will appear. Click it to change the name, icon and description of the book.
1. Import Blueprint - Used to import someone else's blueprint. Copy all the text that they shared, then click this button to add it to the current Blueprint Book.
1. Import Blueprint Book - Used to import someone else's Blueprint Book. Copy all the text that they shared, then click this button to add it to the current Blueprint Book.
1. Export All - Click this to export the 'All Blueprints' book.

You can find my collection of blueprints [here](https://pastebin.com/qd3eAQye) if you want some to get started with.

Below this, you will see a panel that shows the currently open Blueprint Book. At the top of this panel is the path of this book. For example: 'All Blueprints > Machines > Mk1'. If the current Book isn't the 'All Blueprints' book, a 'Back' button will appear. Click it to view the current Book's parent.

In the left panel, all the child Books and Blueprints in the current book will be displayed. Click a panel to see change it's detaisl in the right panel. In the right panel, you can change the name, icon and description for a Book or Blueprint. To change the icon, enter a name of a resource exactly as it is display in the game. For example, 'Assembler MKII'.

At the bottom fo the right panel, you will see two buttons:
1. Export - Click this button to copy some text to your clipoard that will allow you to share the Blueprint / Book.
1. Delete - Click this button 10 times to delete the current Blueprint / Book. Deleting a book will delete all child Books and Blueprints it contains.

#### Saving A Blueprint

1. Copy a region by following the earlier instructions.
1. Press Left Control + X (configurable) to open the Blueprints Library window.
1. Navigate to the Blueprint Book that you want to save this blueprint inside.
1. Click the 'New Blueprint' button.
1. Click the new panel that appears.
1. Enter a name, icon and description for the blueprint.

## Screenshots

![Holograms.png](https://i.imgur.com/KDni89A.png)
![Built Blueprint.png](https://i.imgur.com/ro2vPVb.png)
![Blueprints Library.png](https://i.imgur.com/iMaL8jn.png)
![Build Queue.png](https://i.imgur.com/NuB8U2B.png)

## Config Options

|Name                       |  Type  |Description              |           Default Value           |
|---------------------------|:------:|-------------------------|:---------------------------------:|
|Copy Shortcut              |Shortcut|No description available.|          C + LeftControl          |
|Paste Shortcut             |Shortcut|No description available.|          V + LeftControl          |
|Cancel Shortcut            |Shortcut|No description available.|             Backspace             |
|CW Rotation Shortcut       |Shortcut|No description available.|                 Z                 |
|CCW Rotation Shortcut      |Shortcut|No description available.|          Z + LeftControl          |
|Open Blueprints Shortcut   |Shortcut|No description available.|          X + LeftControl          |
|Lock Position              |Shortcut|No description available.|                 N                 |
|Nudge Left                 |Shortcut|No description available.|             LeftArrow             |
|Nudge Right                |Shortcut|No description available.|             RightArrow            |
|Nudge Forward              |Shortcut|No description available.|              UpArrow              |
|Nudge Backward             |Shortcut|No description available.|             DownArrow             |
|Nudge Up                   |Shortcut|No description available.|        UpArrow + LeftShift        |
|Nudge Down                 |Shortcut|No description available.|       DownArrow + LeftShift       |
|Shrink Copy Region Left    |Shortcut|No description available.|      LeftArrow + LeftControl      |
|Shrink Copy Region Right   |Shortcut|No description available.|      RightArrow + LeftControl     |
|Shrink Copy Region Forward |Shortcut|No description available.|       UpArrow + LeftControl       |
|Shrink Copy Region Backward|Shortcut|No description available.|      DownArrow + LeftControl      |
|Shrink Copy Region Up      |Shortcut|No description available.| UpArrow + LeftShift + LeftControl |
|Shrink Copy Region Down    |Shortcut|No description available.|DownArrow + LeftShift + LeftControl|


## Installation

If you are using Techtonica Mod Loader, you can ignore these steps.

Note, this mod requires use of the BepInEx Update function. If you have not already done so for another mod, follow these instructions:
1. Find your game install folder.
2. Navigate to BepInEx\config.
3. Open BepInEx.cfg.
4. Find the setting "HideGameManagerObject".
5. Set it to "true".
6. Save & close.

### Techtonica Mod Loader Installation

You can download the Techtonica Mod Loader from [here](https://github.com/CubeSuite/TechtonicaModLoader/releases) and use that to install this mod.

### Manual Install Instructions

Note: If you are playing on Gamepass, your game version is likely behind the steam version. Please check the version compatibility chart below.

Your game folder is likely in one of these places:  
    • Steam: (A-Z):/steam/steamapps/common/Techtonica  
    • Gamepass: (A-Z):/XboxGames/Techtonica/Content  
    • Gamepass: Could also be in C:/Program Data/WindowsApps  

1. Download BepInEx v5.4.21 from [here](https://github.com/BepInEx/BepInEx/releases)
1. Follow the installation instructions [here](https://docs.bepinex.dev/articles/user_guide/installation/index.html)
1. Download and install any dependencies.
1. Extract the contents of the .zip file for this mod.
1. Drag the "BepInEx" folder into your game folder.
1. Change config options. 

## Known Issues

- Monorail Pole
  - Monorail poles have three joints when built. Disappear on reload.
- Wall Plant Hologram
  - When pasting a blueprint that contains one of the variants of the 3x3 Wall Plant, holograms won't be rendered correctly. This is due to a game bug.

## Changelog

### V3.0.0

- Added: Embedded GUI
  - Recreate Blueprints library using IMGUI to remove the dependency on the partner program
- Changed: Disable Build Delay
  - Disable build delay now that same ID bug has been patched.
- Changed: Block if can't afford
  - You can no longer start pasting a blueprint if you cannot afford it.

### V2.1.1

- Improved Build Queue GUI
- Fixed an issue where holograms would linger after building.
- Fixed an issue where vertical belts wouldn't have their top port rotated correctly.
- Manual building and deconstructing is now blocked when copying, placing a blueprint or when the Build Queue is active.

### V2.1.0

- Added the Build Queue

### V2.0.0

- Updated for game version 0.3.0e

### V1.1.0

New Features:
- Holograms are now rendered.
- Added Nudging when copying and pasting.
- Blueprints can now be placed on terrain.
- Performance improvements.
- Cancel copying or pasting by with a configurable shortcut.
- Imporoved the 'Not Enough Resources' notification.
- Game auto-unpauses when closing the blueprints GUI.
- Accumulators can now be copied.
- Existing blueprints can now be updated / overwritten.
- Warning popups in the blueprints GUI.

Bug Fixes:
- Fixed machines being invisible, except assemblers that have a recipe set.
- Fixed rotating blueprints, machines no longer overlap and fail to build.
- You can no longer start copying a region while pasting a blueprint.
- Removed some log spam.

### V1.0.0

Initial release.

## Credits



## Disclaimer

Note: NEW Games must be loaded, saved, and reloaded for mods to take effect. Existing saves will auto-apply mods. 
Please be sure to backup your saves before using mods: AppData\LocalLow\Fire Hose Games\Techtonica 
USE AT YOUR OWN RISK! Techtonica Devs do not provide support for Mods, and cannot recover saves damaged by mod usage.

Some assets may come from Techtonica or from the website created and owned by Fire Hose Games, who hold the copyright of Techtonica. All trademarks and registered trademarks present in any images are proprietary to Fire Hose Games.

